'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.querystringify = querystringify;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _httpStatusErrors = require('http-status-errors');

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var QueryStringParser = function () {
  function QueryStringParser(qs, options) {
    (0, _classCallCheck3.default)(this, QueryStringParser);

    this.qs = qs;
    this.options = {};
    _lodash2.default.defaults(this.options, options, { maximumPageSize: Number.POSITIVE_INFINITY, idKey: 'id' });
  }

  (0, _createClass3.default)(QueryStringParser, [{
    key: 'sort',
    value: function sort() {
      if (typeof this._sort === 'undefined') {
        var page = this.page();
        var dir = page && page.reverse ? -1 : 1;

        if (this.qs.sort) {
          var sort = {};

          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = (0, _getIterator3.default)(this.qs.sort.split(',')), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var field = _step.value;

              if (field[0] === '-') {
                sort[field.substring(1)] = -dir;
              } else {
                sort[field] = dir;
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          this._sort = sort;
        } else if (page && page.method === 'after') {
          this._sort = {};
          this._sort[this.options.idKey] = dir;
        } else {
          this._sort = null;
        }
      }

      return this._sort;
    }
  }, {
    key: 'filter',
    value: function filter() {
      if (typeof this._filter === 'undefined') {
        if (this.qs.filter) {
          this._filter = mapValuesDeep(this.qs.filter, function (value) {
            return JSON.parse(value);
          });
        } else {
          this._filter = null;
        }
      }

      return this._filter;
    }
  }, {
    key: 'fields',
    value: function fields(name) {
      if (typeof this._fields === 'undefined') {
        if (this.qs.fields) {
          var fields = {};

          for (var k in this.qs.fields) {
            fields[k] = this.qs.fields[k].split(',');
          }

          this._fields = fields;
        } else {
          this._fields = null;
        }
      }

      if (this._fields && name) {
        return this._fields[name];
      } else {
        return this._fields;
      }
    }
  }, {
    key: 'page',
    value: function page() {
      if (typeof this._page === 'undefined') {
        if (this.qs.page || this.options.defaultPageSize || this.options.defaultPageMethod) {
          this.qs.page = this.qs.page || {};
          var method = _lodash2.default.intersection(_lodash2.default.keys(this.qs.page), ['number', 'offset', 'after', 'before']);

          if (method.length > 1) {
            throw new _httpStatusErrors.BadRequestError('more than one method of paging specified');
          }

          if (method[0] === 'before') {
            method[0] = 'after';
          }

          this._page = _lodash2.default.mapValues(this.qs.page, function (x) {
            return x !== '' ? JSON.parse(x) : void 0;
          });
          this._page.method = method[0] || this.options.defaultPageMethod;
          this._page.size = Math.min(this._page.size || this.options.defaultPageSize, this.options.maximumPageSize);

          switch (this._page.method) {
            case 'number':
              this._page.number = this._page.number || 1;
              break;

            case 'offset':
              this._page.offset = this._page.offset || 0;
              break;

            case 'after':
              if (this.qs.sort) {
                this._page.field = this.qs.sort.match(/^-?([^,]+)/)[1];
                this._page.direction = this.qs.sort[0] === '-' ? -1 : 1;
              } else {
                this._page.field = this.options.idKey;
                this._page.direction = 1;
              }

              if (typeof this.qs.page.before !== 'undefined') {
                this._page.after = this._page.before;
                delete this._page.before;
                this._page.direction = -this._page.direction;
                this._page.reverse = true;
              } else {
                this._page.reverse = false;
              }

              break;
          }
        } else {
          this._page = null;
        }
      }

      return this._page;
    }
  }, {
    key: 'include',
    value: function include() {
      if (typeof this._include === 'undefined') {
        if (this.qs.include) {
          this._include = this.qs.include.split(',');
        } else {
          this._include = null;
        }
      }

      return this._include;
    }
  }]);
  return QueryStringParser;
}();

exports.default = QueryStringParser;
;

function mapValuesDeep(obj, fn) {
  return _lodash2.default.mapValues(obj, function (v) {
    return _lodash2.default.isPlainObject(v) ? mapValuesDeep(v, fn) : fn(v);
  });
}

function querystringify(query) {
  if (!query) {
    return '';
  } else {
    var obj = _lodash2.default.assign({}, query, mapValuesDeep(_lodash2.default.pick(query, 'filter', 'page'), _stringify2.default));

    return '?' + _qs2.default.stringify(obj);
  }
}
