'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function processElement(map, element) {
  for (var name in element.links) {
    if (name[0] !== '$') {
      var relation = map[element.links[name]];

      if (relation) {
        element.attributes[name] = relation.attributes;
      }
    }
  }
}

var ResourceClient = function () {
  function ResourceClient(resource) {
    (0, _classCallCheck3.default)(this, ResourceClient);

    this.resource = resource;

    if (resource.includes) {
      this.includedResources = _lodash2.default.keyBy(resource.includes, function (x) {
        return x.links.$self;
      });
    } else {
      this.includedResources = {};
    }

    if (resource.attributes) {
      processElement(this.includedResources, resource);
    }

    if (resource.elements) {
      _lodash2.default.forEach(resource.elements, processElement.bind(null, this.includedResources));
    }
  }

  (0, _createClass3.default)(ResourceClient, [{
    key: 'value',
    value: function value() {
      return this.resource.attributes;
    }
  }, {
    key: 'toArray',
    value: function toArray() {
      var array = void 0;

      if (this.resource.elements) {
        array = this.resource.elements.map(function (x) {
          return x.attributes;
        });
      } else {
        array = [];
      }

      if (this.resource.meta) array.meta = this.resource.meta;

      return array;
    }
  }]);
  return ResourceClient;
}();

exports.default = ResourceClient;
;
